package com.noxa.njust.lw.xsmd.web;

package ..deTemp.1749553630272;

import cn.com.export.exprotEx;
import co.dc.commons.utils.MD5Utils;
import com.alibaba.fastjson.JSON;
import com.google.common.base.Strings;
import com.google.inject.Inject;
import com.noxa.base.BaseAction;
import com.noxa.cjgl.cjlr.model.chengJi;
import com.noxa.cjgl.cjlr.service.chengJiService;
import com.noxa.cjgl.cjlr.xscj.model.xsChengJi;
import com.noxa.cjgl.cjlr.xscj.service.xsChengJiService;
import com.noxa.frame.Noxa;
import com.noxa.frame.annotations.Action;
import com.noxa.frame.annotations.Controller;
import com.noxa.frame.result.ActionResult;
import com.noxa.frame.tools.Tools;
import com.noxa.mybatis.Page;
import com.noxa.mybatis.base.BaseModel;
import com.noxa.njust.lw.xsmd.model.LwXsmd;
import com.noxa.njust.lw.xsmd.service.LwXsmdService;
import com.noxa.njust.lw.xsmd.service.httpService;
import com.noxa.njust.student.model.Students;
import com.noxa.njust.student.service.StudentsService;
import com.noxa.njust.student.web.ZipCompressor;
import com.noxa.njust.xxw.zc.service.xxwZcService;
import com.spire.doc.Document;
import com.spire.doc.FileFormat;
import com.spire.doc.HeaderFooter;
import com.spire.doc.Section;
import com.spire.doc.TextWatermark;
import com.spire.doc.WatermarkBase;
import com.spire.doc.documents.BackgroundType;
import com.spire.doc.documents.ShapeLineStyle;
import com.spire.doc.documents.ShapeType;
import com.spire.doc.documents.WatermarkLayout;
import com.spire.doc.fields.ShapeObject;
import com.spire.doc.interfaces.IDocument;
import java.awt.Color;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.RandomAccessFile;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Pattern;
import java.util.stream.Collectors;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.Part;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;

@Controller("/lw/xsmd")
public class LwXsmdAction extends BaseAction {
  private static final String lwxsmd_view = "/app/jsp/lw/xsmd/xsmd_view.jsp";
  
  private static final String lwzlupload = "/app/jsp/lw/lwzl/lwzl_upload.jsp";
  
  private static final String lwxsmd_detail = "/app/jsp/njust/lw/xsmd/lwxsmd_detail.jsp";
  
  private static final String lwzwupload = "/app/jsp/lw/gzap/lwzw_upload.jsp";
  
  private static final String fqxwupload = "/app/jsp/lw/gzap/fqxw_upload.jsp";
  
  @Inject
  private LwXsmdService lwXsmdService;
  
  @Inject
  private xxwZcService xxwZcService;
  
  @Inject
  private xsChengJiService xsChengJiService;
  
  @Inject
  private httpService httpService;
  
  public String SignKeyTest() {
    String encryptparams = "764605";
    String encryptkey = "2ebe7855066f4d2d8bc7593109447fec";
    SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH");
    Date curDate = new Date(System.currentTimeMillis());
    String curdatetime = formatter.format(curDate);
    String md5Str = String.valueOf(encryptparams) + encryptkey + curdatetime;
    String result = MD5Utils.getMD5(md5Str);
    return result;
  }
  
  @Action
  public void Test() {
    String result = SignKeyTest();
    HttpURLConnection con = null;
    BufferedReader buffer = null;
    StringBuffer resultBuffer = null;
    try {
      URL url = new URL("https://vims.fanyu.com/toole/jianceorgan/PaperCheckCount.aspx");
      con = (HttpURLConnection)url.openConnection();
      con.setRequestMethod("POST");
      con.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
      con.setDoOutput(true);
      con.setDoInput(true);
      con.setUseCaches(false);
      OutputStreamWriter out = new OutputStreamWriter(con.getOutputStream(), "UTF-8");
      out.write("&sign=" + result);
      out.write("&userid=764605");
      out.flush();
      int responseCode = con.getResponseCode();
      if (responseCode == 200) {
        InputStream inputStream = con.getInputStream();
        resultBuffer = new StringBuffer();
        buffer = new BufferedReader(new InputStreamReader(inputStream));
        String line;
        while ((line = buffer.readLine()) != null)
          resultBuffer.append(line); 
        System.out.println("result:" + resultBuffer.toString());
      } 
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
  
  @Action
  public ActionResult gotocc(String id) {
    int r = 0;
    String url = "https://vims.fanyu.com/toole/jianceorgan/paperbegincheck.aspx";
    String re = fanyu(url, id);
    Map maps = (Map)JSON.parse(re);
    String m = maps.get("message").toString();
    System.out.println(m.indexOf("已经提交"));
    String ids = id.replaceAll(",", "','");
    String updateSql = "UPDATE `lw_xsmd` SET dqcczt='1' WHERE lwccId in( '" + ids + "') and isdel = 0";
    r = this.lwXsmdService.executeSql(updateSql);
    return json(Integer.valueOf(r));
  }
  
  @Action
  public ActionResult hqjg(String id) {
    String url = "https://vims.fanyu.com/toole/jianceorgan/paperlist.aspx";
    String re = fanyu(url, id);
    int r = 0;
    Map maps = (Map)JSON.parse(re);
    String listpaper = maps.get("listpaper").toString().replace("[", "").replace("]", "");
    String listpaper2 = maps.get("listpaper").toString();
    JSONArray arry = JSONArray.fromObject(listpaper2);
    List<Map<String, String>> a = JSONArray.toList(arry, Map.class);
    System.out.println((String)((Map)a.get(0)).get("paperdownurl"));
    for (int i = 0; i < a.size(); i++) {
      Map listpapermaps = a.get(i);
      if (maps.get("success").toString().equals("true") && listpapermaps.get("filestateid").equals(Integer.valueOf(2))) {
        String updateSql = "UPDATE `lw_xsmd` SET dqcczt='2' ,ccyyl = '" + listpapermaps.get("percentage") + "'," + 
          " ccbgdz = '" + listpapermaps.get("paperdownurl") + "' ,zifushu = '" + 
          listpapermaps.get("paperword") + "' " + " WHERE lwccId = '" + listpapermaps.get("paperid") + 
          "' and isdel = 0";
        r += this.lwXsmdService.executeSql(updateSql);
      } else if (listpapermaps.get("filestateid").equals(Integer.valueOf(0))) {
        gotocc(listpapermaps.get("paperid").toString());
      } 
    } 
    return json(Integer.valueOf(r));
  }
  
  @Action
  public String fanyu(String urlS, String id) {
    String result = SignKeyTest();
    HttpURLConnection con = null;
    BufferedReader buffer = null;
    StringBuffer resultBuffer = null;
    try {
      URL url = new URL(urlS);
      con = (HttpURLConnection)url.openConnection();
      con.setRequestMethod("POST");
      con.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
      con.setDoOutput(true);
      con.setDoInput(true);
      con.setUseCaches(false);
      OutputStreamWriter out = new OutputStreamWriter(con.getOutputStream(), "UTF-8");
      out.write("&sign=" + result);
      out.write("&userid=764605");
      out.write("&paperids=" + id);
      out.flush();
      int responseCode = con.getResponseCode();
      if (responseCode == 200) {
        InputStream inputStream = con.getInputStream();
        resultBuffer = new StringBuffer();
        buffer = new BufferedReader(new InputStreamReader(inputStream));
        String line;
        while ((line = buffer.readLine()) != null)
          resultBuffer.append(line); 
        System.out.println("result:" + resultBuffer.toString());
      } 
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return resultBuffer.toString();
  }
  
  @Action
  public String uploadZwToFanyu(String dz, String xm, String ktmc) {
    String result = SignKeyTest();
    String url = "";
    if (xm.length() > 50)
      xm = xm.substring(0, 40); 
    try {
      url = "https://vims.fanyu.com/toole/jianceorgan/papersubmit.aspx?userid=764605&sign=" + result + "&title=" + 
        URLEncoder.encode(ktmc, "utf-8") + "&author=" + URLEncoder.encode(xm, "utf-8");
    } catch (UnsupportedEncodingException e) {
      e.printStackTrace();
    } 
    Map<String, String> fileMap = new HashMap<>();
    fileMap.put("file1", dz);
    String contentType = "";
    String ret = this.httpService.uploadLwzw(url, null, null, fileMap, "UTF-8", "UTF-8");
    Map maps = (Map)JSON.parse(ret);
    System.out.println(maps.get("listpaper").toString());
    String listpaper = maps.get("listpaper").toString().replace("[", "").replace("]", "");
    Map listpapermaps = (Map)JSON.parse(listpaper);
    return listpapermaps.get("paperid").toString();
  }
  
  @Action
  public ActionResult uploadZw(String dbnf, String dbjj, String type) {
    List<LwXsmdService.zipResult> list = new ArrayList<>();
    List<Map<String, Object>> list2 = new ArrayList<>();
    try {
      Part part = this.request.getPart("lwzlfj");
      String header = part.getHeader("content-disposition");
      String fileName = Tools.parseFileName(header);
      String path = "D://" + Tools.getUUID() + fileName.substring(fileName.lastIndexOf("."), fileName.length());
      Files.copy(part.getInputStream(), Paths.get(path, new String[0]), new java.nio.file.CopyOption[0]);
      list = this.lwXsmdService.readZwZipFile(path, fileName, dbnf, dbjj, type);
      (new File(path)).delete();
    } catch (Exception e) {
      e.printStackTrace();
    } 
    for (int i = 0; i < list.size(); i++) {
      String sfzh = ((LwXsmdService.zipResult)list.get(i)).getRealFileName();
      if (sfzh.equals("211941134113"))
        System.out.println(123); 
      String dz = ((LwXsmdService.zipResult)list.get(i)).getZwdz();
      LwXsmd model = new LwXsmd();
      model.setZt("2");
      model.setDbjj(dbjj);
      model.setDbnf(dbnf);
      model.setXh(sfzh);
      model = (LwXsmd)this.lwXsmdService.selectOneByColumn(model);
      if (model != null) {
        LwXsmd updatemodel = new LwXsmd();
        String bt = String.valueOf(model.getXh()) + "-" + model.getXm() + "-" + model.getKtmc();
        updatemodel.setLwccId(uploadZwToFanyu(dz, bt, bt));
        updatemodel.setId(model.getId());
        this.lwXsmdService.updateByColumn(updatemodel);
        Map<String, Object> map = new HashMap<>();
        map.put("fileName", sfzh);
        map.put("describe", ((LwXsmdService.zipResult)list.get(i)).getDescribe());
        list2.add(map);
      } 
    } 
    return json(list2);
  }
  
  public ActionResult deleteFqxw(String keys) {
    keys = "'" + keys.replaceAll(",", "','") + "'";
    String deleteSql = "update lw_xsmd set fqxw = null where id in (" + keys + ")";
    int r = this.lwXsmdService.executeSql(deleteSql);
    return json(Integer.valueOf(r));
  }
  
  @Action
  public ActionResult uploadFqxw(String dbnf, String dbjj) {
    List<LwXsmdService.zipResult> list = new ArrayList<>();
    try {
      Part part = this.request.getPart("lwzlfj");
      String header = part.getHeader("content-disposition");
      String fileName = Tools.parseFileName(header);
      String path = "D://" + Tools.getUUID() + fileName.substring(fileName.lastIndexOf("."), fileName.length());
      Files.copy(part.getInputStream(), Paths.get(path, new String[0]), new java.nio.file.CopyOption[0]);
      list = this.lwXsmdService.readFqxwZipFile(path, fileName, dbnf, dbjj);
      (new File(path)).delete();
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return json(list);
  }
  
  @Action
  public ActionResult modelPageList(LwXsmd model, Page<LwXsmd> page) {
    SignKeyTest();
    model = (model == null) ? new LwXsmd() : model;
    return json(this.lwXsmdService.selectPageByColumn(page, (BaseModel)model));
  }
  
  @Action
  public ActionResult lwzlupload(LwXsmd model) {
    setParam("dbnf", model.getDbnf());
    setParam("dbjj", model.getDbjj());
    return Result("/app/jsp/lw/lwzl/lwzl_upload.jsp");
  }
  
  @Action
  public ActionResult lwzwupload(LwXsmd model, String type) {
    setParam("dbnf", model.getDbnf());
    setParam("dbjj", model.getDbjj());
    setParam("type", type);
    return Result("/app/jsp/lw/gzap/lwzw_upload.jsp");
  }
  
  @Action
  public ActionResult fqxwupload() {
    Calendar calendar = Calendar.getInstance();
    int month = calendar.get(2) + 1;
    if (month > 7 || month == 1) {
      setParam("dbjj", "1");
    } else {
      setParam("dbjj", "0");
    } 
    setParam("dbnf", Integer.valueOf(calendar.get(1)));
    return Result("/app/jsp/lw/gzap/fqxw_upload.jsp");
  }
  
  @Action
  public ActionResult modelDbPageList(LwXsmd model, Page<LwXsmd> page) {
    model = (model == null) ? new LwXsmd() : model;
    return json(this.lwXsmdService.selectDBPageByColumn(page, model));
  }
  
  @Action
  public ActionResult changetime(String nf, String kxxq, String ids, String jssj) {
    SimpleDateFormat date = new SimpleDateFormat("yyyy-MM-dd");
    Date ksdate = new Date();
    try {
      ksdate = date.parse(jssj);
    } catch (ParseException e) {
      e.printStackTrace();
    } 
    String sql = "update  lw_xsmd set jssj = '" + jssj + "' where dbnf = '" + nf + "' and  dbjj = '" + kxxq + 
      "' and  zt != '" + '\002' + "'";
    return json(Integer.valueOf(this.lwXsmdService.executeSql(sql)));
  }
  
  @Action
  public ActionResult modelView(LwXsmd model) {
    if (model != null)
      setParam("model", this.lwXsmdService.selectOneByColumn(model)); 
    return Result("/app/jsp/lw/xsmd/xsmd_view.jsp");
  }
  
  @Action
  public ActionResult modelDetail(LwXsmd model) {
    setParam("model", this.lwXsmdService.selectOneByColumn(model));
    return Result("/app/jsp/njust/lw/xsmd/lwxsmd_detail.jsp");
  }
  
  @Action
  public ActionResult modelSave(LwXsmd model) {
    if (model != null && !Strings.isNullOrEmpty(model.getId())) {
      this.lwXsmdService.updateByColumn(model);
    } else {
      model.setId(Tools.getUUID());
      this.lwXsmdService.insertByColumn(model);
    } 
    return json(model.getId());
  }
  
  @Action
  public ActionResult modelRecycle(LwXsmd model) {
    return json(Integer.valueOf(this.lwXsmdService.recycleByColumn(model)));
  }
  
  @Action
  public ActionResult settingTime(String nf, String kxxq, String ids, String kssj, String jssj) {
    Result r = new Result(this);
    if (!Strings.isNullOrEmpty(ids)) {
      r.result = this.lwXsmdService
        .executeSql(String.format("update lw_xsmd set kssj='%s',jssj='%s' where id in('%s')", new Object[] { kssj, 
              jssj, ids.replace(",", "','") }));
    } else {
      String havingSql = "select * from lw_xsmd where dbnf = '" + nf + "' and dbjj = '" + kxxq + 
        "' AND (yjzt is not null AND yjzt != '0')";
      List<Map<String, Object>> havingList = new ArrayList<>();
      havingList = this.lwXsmdService.queryListMapBysql(havingSql);
      System.out.println(havingList.size());
      if (havingList == null || havingList.size() == 0) {
        String updateHavingSql = "update lw_xsmd set isdel = 1 where dbnf = '" + nf + "' and dbjj = '" + kxxq + 
          "'";
        this.lwXsmdService.executeSql(updateHavingSql);
      } 
      this.lwXsmdService.queryListMapBysql("select * from lwxsmdview ").stream().forEach(s -> {
            LwXsmd l = new LwXsmd();
            LwXsmd l2 = new LwXsmd();
            l2.setDbnf((paramString1 == null) ? "" : paramString1);
            l2.setDbjj((paramString2 == null) ? "" : paramString2);
            l2.setXsid(s.get("id").toString());
            l2.setIsDel(Short.valueOf((short)0));
            l2 = (LwXsmd)this.lwXsmdService.selectOneByColumn(l2);
            if (l2 != null) {
              this.lwXsmdService.updateByColumn(l2);
            } else if (s.get("xq").toString().equals("1") || s.get("xq").toString().equals("3") || s.get("xq").toString().equals("5") || s.get("xq").toString().equals("7") || s.get("xq").toString().equals("9") || s.get("xq").toString().equals("2") || s.get("xq").toString().equals("4") || s.get("xq").toString().equals("6") || s.get("xq").toString().equals("8") || s.get("xq").toString().equals("10")) {
              l.setDbnf((paramString1 == null) ? "" : paramString1);
              l.setDbjj((paramString2 == null) ? "" : paramString2);
              SimpleDateFormat date = new SimpleDateFormat("yyyy-MM-dd");
              Date ksdate = new Date();
              Date jsdate = new Date();
              try {
                ksdate = date.parse(paramString3);
              } catch (ParseException e) {
                e.printStackTrace();
              } 
              try {
                jsdate = date.parse(paramString4);
              } catch (ParseException e) {
                e.printStackTrace();
              } 
              l.setKssj(ksdate);
              l.setJssj(jsdate);
              l.setNf((s.get("dqnf") == null) ? "" : s.get("dqnf").toString());
              l.setKxxq((s.get("dqjj") == null) ? "" : s.get("dqjj").toString());
              l.setZdid((s.get("zdid") == null) ? "" : s.get("zdid").toString());
              l.setZd((s.get("zd") == null) ? "" : s.get("zd").toString());
              l.setNj((s.get("nj") == null) ? "" : s.get("nj").toString());
              l.setBjid((s.get("bjid") == null) ? "" : s.get("bjid").toString());
              l.setBj((s.get("bj") == null) ? "" : s.get("bj").toString());
              l.setZyid((s.get("zyid") == null) ? "" : s.get("zyid").toString());
              l.setZy((s.get("zy") == null) ? "" : s.get("zy").toString());
              l.setXq((s.get("xq") == null) ? "" : s.get("xq").toString());
              l.setXsid((s.get("id") == null) ? "" : s.get("id").toString());
              l.setXm((s.get("xm") == null) ? "" : s.get("xm").toString());
              l.setXh((s.get("xh") == null) ? "" : s.get("xh").toString());
              l.setSfzh((s.get("sfzh") == null) ? "" : s.get("sfzh").toString());
              if (s.get("xjval").toString().equals("1")) {
                l.setXj("1");
                l.setXj((s.get("xjval") == null) ? "" : s.get("xjval").toString());
                l.setZt((s.get("ztval") == null) ? "" : s.get("ztval").toString());
              } else {
                l.setXj("0");
                l.setZt("2");
              } 
              LwXsmd haveOld = new LwXsmd();
              haveOld.setXsid(s.get("id").toString());
              List<LwXsmd> oldList = this.lwXsmdService.selectAllByColumn(haveOld);
              if (oldList.size() != 0) {
                l.setXj("1");
                l.setZt("0");
              } 
              paramResult.result += this.lwXsmdService.insertByColumn(l);
            } else {
              l.setXsid(s.get("id").toString());
              List<LwXsmd> list = this.lwXsmdService.selectAllByColumn(l);
              l = new LwXsmd();
              l.setDbnf((paramString1 == null) ? "" : paramString1);
              l.setDbjj((paramString2 == null) ? "" : paramString2);
              SimpleDateFormat date = new SimpleDateFormat("yyyy-MM-dd");
              Date ksdate = new Date();
              Date jsdate = new Date();
              try {
                ksdate = date.parse(paramString3);
              } catch (ParseException e) {
                e.printStackTrace();
              } 
              try {
                jsdate = date.parse(paramString4);
              } catch (ParseException e) {
                e.printStackTrace();
              } 
              l.setKssj(ksdate);
              l.setJssj(jsdate);
              l.setNf((s.get("dqnf") == null) ? "" : s.get("dqnf").toString());
              l.setKxxq((s.get("dqjj") == null) ? "" : s.get("dqjj").toString());
              l.setZdid((s.get("zdid") == null) ? "" : s.get("zdid").toString());
              l.setZd((s.get("zd") == null) ? "" : s.get("zd").toString());
              l.setNj((s.get("nj") == null) ? "" : s.get("nj").toString());
              l.setBjid((s.get("bjid") == null) ? "" : s.get("bjid").toString());
              l.setBj((s.get("bj") == null) ? "" : s.get("bj").toString());
              l.setZyid((s.get("zyid") == null) ? "" : s.get("zyid").toString());
              l.setZy((s.get("zy") == null) ? "" : s.get("zy").toString());
              l.setXq((s.get("xq") == null) ? "" : s.get("xq").toString());
              l.setXsid((s.get("id") == null) ? "" : s.get("id").toString());
              l.setXm((s.get("xm") == null) ? "" : s.get("xm").toString());
              l.setXh((s.get("xh") == null) ? "" : s.get("xh").toString());
              l.setSfzh((s.get("sfzh") == null) ? "" : s.get("sfzh").toString());
              l.setXj("1");
              l.setZt("0");
              paramResult.result += this.lwXsmdService.insertByColumn(l);
            } 
          });
    } 
    return json(Integer.valueOf(r.result));
  }
  
  @Action
  public ActionResult getStudens() {
    Result r = new Result(this);
    this.lwXsmdService.queryListMapBysql("select * from lwxsmdview ").stream().forEach(s -> {
          LwXsmd l = new LwXsmd();
          l.setDbnf((s.get("dbnf") == null) ? "" : s.get("dbnf").toString());
          l.setDbjj((s.get("dbjj") == null) ? "" : s.get("dbjj").toString());
          l.setNf((s.get("dqnf") == null) ? "" : s.get("dqnf").toString());
          l.setKxxq((s.get("dqjj") == null) ? "" : s.get("dqjj").toString());
          l.setZdid((s.get("zdid") == null) ? "" : s.get("zdid").toString());
          l.setZd((s.get("zd") == null) ? "" : s.get("zd").toString());
          l.setNj((s.get("nj") == null) ? "" : s.get("nj").toString());
          l.setBjid((s.get("bjid") == null) ? "" : s.get("bjid").toString());
          l.setBj((s.get("bj") == null) ? "" : s.get("bj").toString());
          l.setZyid((s.get("zyid") == null) ? "" : s.get("zyid").toString());
          l.setZy((s.get("zy") == null) ? "" : s.get("zy").toString());
          l.setXq((s.get("xq") == null) ? "" : s.get("xq").toString());
          l.setXsid((s.get("id") == null) ? "" : s.get("id").toString());
          l.setXm((s.get("xm") == null) ? "" : s.get("xm").toString());
          l.setXh((s.get("xh") == null) ? "" : s.get("xh").toString());
          l.setSfzh((s.get("sfzh") == null) ? "" : s.get("sfzh").toString());
          l.setXj((s.get("xjval") == null) ? "" : s.get("xjval").toString());
          l.setZt((s.get("ztval") == null) ? "" : s.get("ztval").toString());
          paramResult.result += this.lwXsmdService.insertByColumn(l);
        });
    return json(Integer.valueOf(r.result));
  }
  
  @Action
  public ActionResult addStudens(String bjId, String xsId, String xsdbnf, String xsdbxq, String xskssj, String xsjssj, String bjdbnf, String bjdbxq, String bjkssj, String bjjssj) {
    StringBuffer sql = new StringBuffer();
    sql.append(" select case when r.xn=r.dbnf and r.xqjj=r.dbjj then '2' else '0' end ztval,r.* from (");
    sql.append(" select case dqjj+1 when 1 then dqnf else dqnf + 1 end dbnf,");
    sql.append(" case dqjj+1 when 1 then '1' else '0' end dbjj,r.* from (");
    sql.append(" select year(NOW()) dqnf,case when month(now()) >=3 and month(now()) <7 then '0' ");
    sql.append(" when month(now()) >=7 and month(now()) <=12 then '1' end dqjj,s.zdId,s.zd,");
    sql.append(" s.nj,b.id bjId,b.name bj,s.zyId,s.zy,k.xq,s.id,s.code xh,s.xm,s.sfzh,s.IsGraduate,");
    sql.append(
        " s.sfzx,k.id kid,c.id cid,c.zpcj,l.id lId,k.xn,case mod(k.xq,2) when 0 then '1' else '0' end xqjj ");
    sql.append(" from sm_students s left join sm_bj b on (s.bjId = b.id and b.IsDel=0)");
    sql.append(" left join jxgl_jxjh_kc k on(b.jhid = k.jhid and k.IsDel=0 and k.kcdm='07002')");
    sql.append(
        " left join cjgl_cjlr_cj c on (s.id = c.stuId and c.kcdm='07002' and  c.IsDel=0 AND c.bjid = s.bjId)");
    sql.append(" left join lw_xsmd l on (l.xsid = s.id and l.IsDel = 0)");
    sql.append(" where s.IsDel=0");
    if (!Strings.isNullOrEmpty(bjId))
      sql.append(" and b.id='" + bjId + "' "); 
    if (!Strings.isNullOrEmpty(xsId))
      sql.append(" and s.id='" + xsId + "'"); 
    sql.append(" ) r )r");
    List<Result> list = (List<Result>)this.lwXsmdService.queryListMapBysql(sql.toString()).stream().map(s -> {
          LwXsmd l = new LwXsmd();
          String nf = "";
          String xq = "";
          String kssj = "";
          String jssj = "";
          if (paramString1 == "" || paramString1 == null) {
            nf = paramString2;
            xq = paramString3;
            kssj = paramString4;
            jssj = paramString5;
          } else {
            nf = paramString1;
            xq = paramString6;
            kssj = paramString7;
            jssj = paramString8;
          } 
          SimpleDateFormat date = new SimpleDateFormat("yyyy-MM-dd");
          Date ksdate = new Date();
          Date jsdate = new Date();
          try {
            ksdate = date.parse(kssj);
          } catch (ParseException e) {
            e.printStackTrace();
          } 
          try {
            jsdate = date.parse(jssj);
          } catch (ParseException e) {
            e.printStackTrace();
          } 
          l.setKssj(ksdate);
          l.setJssj(jsdate);
          l.setDbnf((nf == null) ? "" : nf);
          l.setDbjj((xq == null) ? "" : xq);
          l.setNf((s.get("dqnf") == null) ? "" : s.get("dqnf").toString());
          l.setKxxq((s.get("dqjj") == null) ? "" : s.get("dqjj").toString());
          l.setZdid((s.get("zdId") == null) ? "" : s.get("zdId").toString());
          l.setZd((s.get("zd") == null) ? "" : s.get("zd").toString());
          l.setNj((s.get("nj") == null) ? "" : s.get("nj").toString());
          l.setBjid((s.get("bjId") == null) ? "" : s.get("bjId").toString());
          l.setBj((s.get("bj") == null) ? "" : s.get("bj").toString());
          l.setZyid((s.get("zyId") == null) ? "" : s.get("zyId").toString());
          l.setZy((s.get("zy") == null) ? "" : s.get("zy").toString());
          l.setXq((s.get("xq") == null) ? "" : s.get("xq").toString());
          l.setXsid((s.get("id") == null) ? "" : s.get("id").toString());
          l.setXm((s.get("xm") == null) ? "" : s.get("xm").toString());
          l.setXh((s.get("xh") == null) ? "" : s.get("xh").toString());
          l.setSfzh((s.get("sfzh") == null) ? "" : s.get("sfzh").toString());
          String zt = (s.get("ztval") == null) ? "" : s.get("ztval").toString();
          l.setZt("1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType()) ? "0" : zt);
          String sfzx = (s.get("sfzx") == null) ? "" : s.get("sfzx").toString();
          String kid = (s.get("kid") == null) ? "" : s.get("kid").toString();
          String cj = (s.get("zpcj") == null) ? "0" : s.get("zpcj").toString();
          String lId = (s.get("lId") == null) ? "" : s.get("lId").toString();
          Result result = new Result(this);
          Result.access$0(result, l.getXm());
          Result.access$1(result, l.getXh());
          int a = 60;
          try {
            a = Integer.parseInt(cj);
          } catch (NumberFormatException e) {
            e.printStackTrace();
          } 
          if (sfzx.equals("1")) {
            l.setXj("0");
          } else {
            l.setXj("1");
          } 
          if (!kid.equals("") && (cj.equals("") || cj.equals("不合格") || cj.equals("不及格") || a < 60))
            if ((!s.get("dbjj").toString().equals(xq) || !s.get("dbnf").toString().equals(nf)) && !Strings.isNullOrEmpty(l.getXj())) {
              xsChengJi xscj = new xsChengJi();
              xscj.setBjid(l.getBjid());
              xscj.setKcdm("07002");
              List<xsChengJi> bjxscj = this.xsChengJiService.selectAllByColumn(xscj);
              xscj.setXh(l.getXh());
              List<xsChengJi> grxscj = this.xsChengJiService.selectAllByColumn(xscj);
              if (bjxscj.size() > 0 && grxscj.size() == 0) {
                xscj = bjxscj.get(0);
                xscj.setId(Tools.getUUID());
                xscj.setZpcj("");
                xscj.setXm(l.getXm());
                xscj.setXh(l.getXh());
                xscj.setSfmxmk("0");
                xscj.setStuId(l.getXsid());
                this.xsChengJiService.insertByColumn(xscj);
              } 
              this.lwXsmdService.insertByColumn(l);
              Result.access$2(result, "通过");
            }  
          if (kid.equals("")) {
            Result.access$2(result, "无毕业设计课程");
          } else if (!cj.equals("") && !cj.equals("不合格") && !cj.equals("不及格") && a >= 60) {
            xsChengJi xscj = new xsChengJi();
            xscj.setBjid(l.getBjid());
            xscj.setKcdm("07002");
            List<xsChengJi> bjxscj = this.xsChengJiService.selectAllByColumn(xscj);
            xscj.setXh(l.getXh());
            List<xsChengJi> grxscj = this.xsChengJiService.selectAllByColumn(xscj);
            if (bjxscj.size() > 0 && grxscj.size() == 0) {
              xscj = bjxscj.get(0);
              xscj.setId(Tools.getUUID());
              xscj.setZpcj("");
              xscj.setXm(l.getXm());
              xscj.setXh(l.getXh());
              xscj.setSfmxmk("0");
              xscj.setStuId(l.getXsid());
              this.xsChengJiService.insertByColumn(xscj);
            } 
            Result.access$2(result, "论文成绩已存在");
          } else if (!lId.equals("")) {
            xsChengJi xscj = new xsChengJi();
            xscj.setBjid(l.getBjid());
            xscj.setKcdm("07002");
            List<xsChengJi> bjxscj = this.xsChengJiService.selectAllByColumn(xscj);
            xscj.setXh(l.getXh());
            List<xsChengJi> grxscj = this.xsChengJiService.selectAllByColumn(xscj);
            if (bjxscj.size() > 0 && grxscj.size() == 0) {
              xscj = bjxscj.get(0);
              xscj.setId(Tools.getUUID());
              xscj.setZpcj("");
              xscj.setXm(l.getXm());
              xscj.setXh(l.getXh());
              xscj.setSfmxmk("0");
              xscj.setStuId(l.getXsid());
              this.xsChengJiService.insertByColumn(xscj);
            } 
            Result.access$2(result, "已在毕业设计学生名单中");
          } 
          return result;
        }).collect(Collectors.toList());
    return json(list);
  }
  
  @Action
  public ActionResult uploadLw(String dbnf, String dbjj) {
    List<LwXsmdService.zipResult> list = new ArrayList<>();
    List<Map<String, Object>> list2 = new ArrayList<>();
    try {
      Part part = this.request.getPart("lwzlfj");
      String header = part.getHeader("content-disposition");
      String fileName = Tools.parseFileName(header);
      String path = "D://" + Tools.getUUID() + fileName.substring(fileName.lastIndexOf("."), fileName.length());
      Files.copy(part.getInputStream(), Paths.get(path, new String[0]), new java.nio.file.CopyOption[0]);
      list = this.lwXsmdService.readZipFile(path, fileName, dbnf, dbjj);
      (new File(path)).delete();
    } catch (Exception e) {
      e.printStackTrace();
    } 
    for (int i = 0; i < list.size(); i++) {
      String sfzh = ((LwXsmdService.zipResult)list.get(i)).getRealFileName().substring(((LwXsmdService.zipResult)list.get(i)).getRealFileName().length() - 18);
      Map<String, Object> map = new HashMap<>();
      map.put("fileName", sfzh);
      map.put("describe", ((LwXsmdService.zipResult)list.get(i)).getDescribe());
      list2.add(map);
    } 
    return json(list2);
  }
  
  @Action
  public ActionResult batchOperation(String keys, String zt) {
    if (zt.equals("1")) {
      int j = 0;
      String str = keys.replace(",", "");
      for (int k = 0; k < str.length() / 32; k++) {
        LwXsmd model = new LwXsmd();
        String id = str.substring(k * 32, k * 32 + 32);
        model.setId(id);
        model = (LwXsmd)this.lwXsmdService.selectOneByColumn(model);
        Date date = new Date();
        long dqsj = date.getTime();
        long jssj = model.getJssj().getTime() + 86400000L;
        System.out.println(date.getTime());
        System.out.println(model.getJssj().getTime() + 86400000L);
        if (dqsj <= jssj) {
          this.lwXsmdService.executeSql(
              String.format("update lw_xsmd set zt='%s' where id = ('%s')", new Object[] { zt, model.getId() }));
          j++;
        } 
      } 
      return json(Integer.valueOf(j));
    } 
    int n = 0;
    String allkey = keys.replace(",", "");
    for (int i = 0; i < allkey.length() / 32; i++) {
      LwXsmd model = new LwXsmd();
      String id = allkey.substring(i * 32, i * 32 + 32);
      model.setId(id);
      model = (LwXsmd)this.lwXsmdService.selectOneByColumn(model);
      Date date = new Date();
      long dqsj = date.getTime();
      long jssj = model.getJssj().getTime() + 86400000L;
      System.out.println(date.getTime());
      System.out.println(model.getJssj().getTime() + 86400000L);
      if (dqsj <= jssj) {
        this.lwXsmdService.executeSql(
            String.format("update lw_xsmd set zt='%s' where id = ('%s')", new Object[] { zt, model.getId() }));
        n++;
      } 
    } 
    return json(Integer.valueOf(n));
  }
  
  @Action
  public ActionResult qxcctg(String keys) {
    int n = 0;
    String allkey = keys.replace(",", "','");
    String sql = "update lw_xsmd set cctg = '不通过' where id in ('" + allkey + "')";
    n = this.lwXsmdService.executeSql(sql);
    return json(Integer.valueOf(n));
  }
  
  @Action
  public void exportExcel(LwXsmd model) {
    StringBuffer sql = new StringBuffer();
    sql.append(" select nf,case kxxq when '0' then '春' else '秋' END");
    sql.append(" kxxq ,zd,zy,nj,bj,count(*) rs from lw_xsmd");
    sql.append(" where IsDel=0");
    if (!Strings.isNullOrEmpty(model.getZdid()) || 
      "1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType())) {
      String zdId = "1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType()) ? 
        this.lwXsmdService.getLoginTeacher().getZdName() : 
        model.getZdid();
      sql.append(" and zdid = '" + zdId + "'");
    } 
    if (!Strings.isNullOrEmpty(model.getNf()))
      sql.append(" and nf = '" + model.getNf() + "'"); 
    if (!Strings.isNullOrEmpty(model.getKxxq()))
      sql.append(" and kxxq = '" + model.getKxxq() + "'"); 
    if (!Strings.isNullOrEmpty(model.getZyid()))
      sql.append(" and zyid = '" + model.getZyid() + "'"); 
    if (!Strings.isNullOrEmpty(model.getNj()))
      sql.append(" and nj = '" + model.getNj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getBjid()))
      sql.append(" and bjid = '" + model.getBjid() + "'"); 
    if (!Strings.isNullOrEmpty(model.getXh()))
      sql.append(" and xh = '" + model.getXh() + "'"); 
    if (!Strings.isNullOrEmpty(model.getXm()))
      sql.append(" and xm = '" + model.getXm() + "'"); 
    if (!Strings.isNullOrEmpty(model.getSfzh()))
      sql.append(" and sfzh = '" + model.getSfzh() + "'"); 
    if (!Strings.isNullOrEmpty(model.getXj()))
      sql.append(" and xj = '" + model.getXj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getZt())) {
      sql.append(" and zt = '" + model.getZt() + "'");
    } else {
      sql.append(" and zt = '2'");
    } 
    sql.append(" group by nf,kxxq,zd,zy,nj,bj");
    sql.append(" order by nf desc,kxxq,zd ,zy,nj,bj ");
    exprotEx<BaseModel> ex = new exprotEx();
    Map<String, String> headers = new LinkedHashMap<>();
    headers.put("nf", "年份");
    headers.put("kxxq", "开学学期");
    headers.put("zd", "站点");
    headers.put("zy", "专业");
    headers.put("nj", "年级");
    headers.put("bj", "班级");
    headers.put("rs", "人数");
    ex.exportExcel(headers, (String)sql, this.response, "毕业设计学生名单汇总", null);
  }
  
  @Action
  public ActionResult modelRecycles(String keys) {
    if (Strings.isNullOrEmpty(keys))
      return json(Integer.valueOf(0)); 
    int n = 0;
    String allkey = keys.replace(",", "");
    for (int i = 0; i < allkey.length() / 32; i++) {
      LwXsmd model = new LwXsmd();
      String id = allkey.substring(i * 32, i * 32 + 32);
      model.setId(id);
      model = (LwXsmd)this.lwXsmdService.selectOneByColumn(model);
      Date date = new Date();
      long dqsj = date.getTime();
      long jssj = model.getJssj().getTime() + 86400000L;
      System.out.println(date.getTime());
      System.out.println(model.getJssj().getTime() + 86400000L);
      if (dqsj <= jssj) {
        model.setId(model.getId());
        this.lwXsmdService.recycleByColumn(model);
        n++;
      } 
    } 
    return json(Integer.valueOf(n));
  }
  
  @Action
  public void lwDownload(String path, String sfzh) {
    try {
      this.response.setCharacterEncoding("UTF-8");
      this.response.setContentType("application/");
      this.response.setHeader("content-disposition", "attachment;filename=" + new String(String.valueOf(sfzh) + ".zip"));
      Files.copy(Paths.get(path, new String[0]), (OutputStream)this.response.getOutputStream());
    } catch (IOException e) {
      e.printStackTrace();
    } 
  }
  
  @Action
  public void lwZwDownload(String time, String path, String xh, LwXsmd model) throws IOException {
    if (xh != null && !xh.equals("")) {
      String tittleSql = "SELECT stu.CODE, stu.xm, zybb.gjdm, zy.bysjlx,MAX(zybb.bb)  FROM sm_students stu  LEFT JOIN jichuxinxi_zysz zy ON ( stu.zyId = zy.id )  LEFT JOIN JICHUXINXI_ZYSZ_BB zybb ON ( zybb.zydm = zy.zyCode )  WHERE stu.`code` = '" + 
        
        xh + 
        "'  AND stu.IsDel = 0  AND zy.IsDel = 0";
      Map<String, Object> stu = this.lwXsmdService.queryMapBysql(tittleSql);
      String sjlx = "LW";
      if (stu.get("bysjlx") != null)
        sjlx = stu.get("bysjlx").toString(); 
      String tittle = String.valueOf(time) + "_32_10288" + stu.get("gjdm").toString() + "_" + xh + "_" + sjlx + "_001" + 
        path.substring(path.indexOf("."));
      try {
        this.response.setCharacterEncoding("UTF-8");
        this.response.setContentType("application/");
        this.response.setHeader("content-disposition", "attachment;filename=" + tittle);
        Files.copy(Paths.get(path, new String[0]), (OutputStream)this.response.getOutputStream());
      } catch (IOException e) {
        e.printStackTrace();
      } 
    } else {
      List<LwXsmd> stuList = this.lwXsmdService.selectAllByColumn(model);
      String uuid = Tools.getUUID();
      String pathAll = "D:" + File.separator + uuid;
      File file = new File(pathAll);
      if (!file.exists())
        file.mkdirs(); 
      String lwPath = "";
      for (int i = 0; i < stuList.size(); i++) {
        lwPath = ((LwXsmd)stuList.get(i)).getLwzwdz();
        if (lwPath != null && !lwPath.equals("")) {
          String tittleSql = "SELECT stu.CODE, stu.xm, zybb.gjdm, zy.bysjlx,MAX(zybb.bb)  FROM sm_students stu  LEFT JOIN jichuxinxi_zysz zy ON ( stu.zyId = zy.id )  LEFT JOIN JICHUXINXI_ZYSZ_BB zybb ON ( zybb.zydm = zy.zyCode )  WHERE stu.`code` = '" + (
            
            (LwXsmd)stuList.get(i)).getXh() + 
            "'  AND stu.IsDel = 0  AND zy.IsDel = 0";
          Map<String, Object> stu = this.lwXsmdService.queryMapBysql(tittleSql);
          String sjlx = "LW";
          if (stu.get("bysjlx") != null)
            sjlx = stu.get("bysjlx").toString(); 
          String tittle = String.valueOf(time) + "_32_10288" + stu.get("gjdm").toString() + "_" + ((LwXsmd)stuList.get(i)).getXh() + "_" + sjlx + "_001" + 
            lwPath.substring(lwPath.indexOf("."));
          try {
            Path target = (new File(String.valueOf(pathAll) + File.separator + tittle)).toPath();
            Files.copy(Paths.get(lwPath, new String[0]), target, new java.nio.file.CopyOption[0]);
          } catch (IOException e) {
            e.printStackTrace();
          } 
        } 
      } 
      String zipAddress = "D:/" + Tools.getUUID() + ".zip";
      ZipCompressor zc = new ZipCompressor(zipAddress);
      zc.compress(pathAll);
      this.response.setCharacterEncoding("UTF-8");
      this.response.setContentType("application/");
      this.response.setHeader("content-disposition", 
          "attachment;filename=" + new String("论文正文".getBytes("gb2312"), "ISO8859-1") + ".zip");
      File files = new File(zipAddress);
      FileInputStream in = new FileInputStream(files);
      ServletOutputStream servletOutputStream = this.response.getOutputStream();
      int b;
      while ((b = in.read()) != -1)
        servletOutputStream.write(b); 
      in.close();
      servletOutputStream.flush();
      servletOutputStream.close();
      files.delete();
      deleteFile(new File(pathAll));
    } 
  }
  
  public static byte[] toByteArray3(String filename) throws IOException {
    FileChannel fc = null;
    try {
      fc = (new RandomAccessFile(filename, "r")).getChannel();
      MappedByteBuffer byteBuffer = fc.map(FileChannel.MapMode.READ_ONLY, 0L, 
          fc.size()).load();
      System.out.println(byteBuffer.isLoaded());
      byte[] result = new byte[(int)fc.size()];
      if (byteBuffer.remaining() > 0)
        byteBuffer.get(result, 0, byteBuffer.remaining()); 
      return result;
    } catch (IOException e) {
      e.printStackTrace();
      throw e;
    } finally {
      try {
        fc.close();
      } catch (IOException e) {
        e.printStackTrace();
      } 
    } 
  }
  
  @Action
  public void lwZwShuiYinDownload(LwXsmd model) throws Exception {
    if (!Strings.isNullOrEmpty(model.getZdid()) || "1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType())) {
      String zdId = "1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType()) ? 
        this.lwXsmdService.getLoginTeacher().getZdName() : 
        model.getZdid();
      model.setZdid(zdId);
    } 
    List<LwXsmd> stuList = this.lwXsmdService.selectAllByColumn(model);
    String uuid = Tools.getUUID();
    String pathAll = "D:" + File.separator + uuid;
    File file = new File(pathAll);
    if (!file.exists())
      file.mkdirs(); 
    String path = "";
    for (int i = 0; i < stuList.size(); i++) {
      if (((LwXsmd)stuList.get(i)).getLwzwdz() != null) {
        path = addShuiYin(((LwXsmd)stuList.get(i)).getLwzwdz());
        String tittle = String.valueOf(((LwXsmd)stuList.get(i)).getXm()) + "_" + ((LwXsmd)stuList.get(i)).getXh() + path.substring(path.indexOf("."));
        try {
          Path target = (new File(String.valueOf(pathAll) + File.separator + tittle)).toPath();
          Files.copy(Paths.get(path, new String[0]), target, new java.nio.file.CopyOption[0]);
          Files.delete(Paths.get(path, new String[0]));
        } catch (IOException e) {
          e.printStackTrace();
        } 
      } 
    } 
    String zipAddress = "D:/" + Tools.getUUID() + ".zip";
    ZipCompressor zc = new ZipCompressor(zipAddress);
    zc.compress(pathAll);
    this.response.setCharacterEncoding("UTF-8");
    this.response.setContentType("application/");
    this.response.setHeader("content-disposition", 
        "attachment;filename=" + new String("论文稿件".getBytes("gb2312"), "ISO8859-1") + ".zip");
    File files = new File(zipAddress);
    FileInputStream in = new FileInputStream(files);
    ServletOutputStream servletOutputStream = this.response.getOutputStream();
    int b;
    while ((b = in.read()) != -1)
      servletOutputStream.write(b); 
    in.close();
    servletOutputStream.flush();
    servletOutputStream.close();
    files.delete();
    deleteFile(new File(pathAll));
  }
  
  public static void deleteFile(File file) {
    if (file.exists()) {
      if (file.isFile()) {
        file.delete();
      } else if (file.isDirectory()) {
        File[] files = file.listFiles();
        for (int i = 0; i < files.length; i++)
          deleteFile(files[i]); 
      } 
      file.delete();
    } 
  }
  
  public String addShuiYin(String path) {
    Document doc = 
      new Document();
    doc.loadFromFile(path);
    doc.getBackground().setType(BackgroundType.Color);
    doc.getBackground().setColor(Color.white);
    ShapeObject shape = new ShapeObject((IDocument)doc, ShapeType.Text_Plain_Text);
    shape.setWidth(180.0F);
    shape.setHeight(20.0F);
    shape.setVerticalPosition(30.0F);
    shape.setHorizontalPosition(20.0F);
    shape.setRotation(315.0D);
    shape.getWordArt().setFontFamily("宋体");
    shape.getWordArt().setText("南京理工大学继续教育学院");
    shape.setFillColor(new Color(192, 192, 192, 255));
    shape.setLineStyle(ShapeLineStyle.Single);
    shape.setStrokeColor(new Color(192, 192, 192, 255));
    shape.setStrokeWeight(1.0D);
    TextWatermark txtWatermark = new TextWatermark();
    txtWatermark.setText("南京理工大学继续教育学院");
    txtWatermark.setFontSize(60.0F);
    txtWatermark.setColor(Color.red);
    txtWatermark.setLayout(WatermarkLayout.Diagonal);
    for (int n = 0; n < doc.getSections().getCount(); n++) {
      Section section = doc.getSections().get(n);
      HeaderFooter header = section.getHeadersFooters().getHeader();
      if (header.getFirstParagraph() != null && header.getFirstParagraph().getText().length() == 0)
        header.getParagraphs().clear(); 
      section.getDocument().setWatermark((WatermarkBase)txtWatermark);
    } 
    String id = Tools.getUUID();
    doc.saveToFile("D:\\" + id + ".docx", FileFormat.Docx_2013);
    return "D:\\" + id + ".docx";
  }
  
  @Action
  public void zdjsModelDownload(LwXsmd model) {
    StringBuffer sql = new StringBuffer();
    sql.append(" select zd,zy,bj,xh,xm,'' as ktmc, '' as jsxm, '' as sfzh");
    sql.append(" from lw_xsmd where IsDel=0 and zt=2");
    if (!Strings.isNullOrEmpty(model.getZdid()) || 
      "1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType())) {
      String zdId = "1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType()) ? 
        this.lwXsmdService.getLoginTeacher().getZdName() : 
        model.getZdid();
      sql.append(" and zdid = '" + zdId + "'");
    } 
    if (!Strings.isNullOrEmpty(model.getNf()))
      sql.append(" and nf = '" + model.getNf() + "'"); 
    if (!Strings.isNullOrEmpty(model.getDbjj()))
      sql.append(" and dbjj = '" + model.getDbjj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getXh()))
      sql.append(" and xh = '" + model.getXh() + "'"); 
    if (!Strings.isNullOrEmpty(model.getXm()))
      sql.append(" and xm = '" + model.getXm() + "'"); 
    if (!Strings.isNullOrEmpty(model.getCj()))
      sql.append(" and cj = '" + model.getCj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getDbnf()))
      sql.append(" and dbnf = '" + model.getDbnf() + "'"); 
    if (!Strings.isNullOrEmpty(model.getNj()))
      sql.append(" and nj = '" + model.getNj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getBjid()))
      sql.append(" and bjid = '" + model.getBjid() + "' "); 
    sql.append(" group by zdid,zyid,bjid,id");
    sql.append(" order by nf desc,zdid,zyid,bjid");
    exprotEx<BaseModel> ex = new exprotEx();
    Map<String, String> headers = new LinkedHashMap<>();
    headers.put("zd", "站点");
    headers.put("zy", "专业");
    headers.put("bj", "班级");
    headers.put("xh", "学号");
    headers.put("xm", "学生姓名");
    headers.put("ktmc", "课题名称");
    headers.put("jsxm", "教师姓名");
    headers.put("sfzh", "身份证号");
    ex.exportExcel(headers, (String)sql, this.response, "指导教师", null);
  }
  
  public static String getWaterMarkStyle(String styleStr, double height) {
    Pattern p = Pattern.compile(";");
    String[] strs = p.split(styleStr);
    byte b;
    int i;
    String[] arrayOfString1;
    for (i = (arrayOfString1 = strs).length, b = 0; b < i; ) {
      String str = arrayOfString1[b];
      if (str.startsWith("height:")) {
        String heightStr = "height:" + height + "pt";
        styleStr = styleStr.replace(str, heightStr);
        break;
      } 
      b++;
    } 
    return styleStr;
  }
  
  @Action
  public void sfccModelDownload(LwXsmd model) {
    StringBuffer sql = new StringBuffer();
    sql.append(
        " select dbnf, case  when dbjj = 1 then '秋' when  dbjj = 0 then '春' end as dbjj, zd,zy,bj,xh,xm,ktmc");
    sql.append(" from lw_xsmd where IsDel=0 and zt=2");
    if (!Strings.isNullOrEmpty(model.getZdid()) || 
      "1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType())) {
      String zdId = "1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType()) ? 
        this.lwXsmdService.getLoginTeacher().getZdName() : 
        model.getZdid();
      sql.append(" and zdid = '" + zdId + "'");
    } 
    if (!Strings.isNullOrEmpty(model.getNf()))
      sql.append(" and nf = '" + model.getNf() + "'"); 
    if (!Strings.isNullOrEmpty(model.getDbjj()))
      sql.append(" and dbjj = '" + model.getDbjj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getXh()))
      sql.append(" and xh = '" + model.getXh() + "'"); 
    if (!Strings.isNullOrEmpty(model.getXm()))
      sql.append(" and xm = '" + model.getXm() + "'"); 
    if (!Strings.isNullOrEmpty(model.getCj()))
      sql.append(" and cj = '" + model.getCj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getDbnf()))
      sql.append(" and dbnf = '" + model.getDbnf() + "'"); 
    if (!Strings.isNullOrEmpty(model.getNj()))
      sql.append(" and nj = '" + model.getNj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getBjid()))
      sql.append(" and bjid = '" + model.getBjid() + "' "); 
    sql.append(" group by zdid,zyid,bjid,id");
    sql.append(" order by nf desc,zdid,zyid,bjid,xh");
    exprotEx<BaseModel> ex = new exprotEx();
    Map<String, String> headers = new LinkedHashMap<>();
    headers.put("dbnf", "答辩年份");
    headers.put("dbjj", "答辩学期");
    headers.put("zd", "站点");
    headers.put("zy", "专业");
    headers.put("bj", "班级");
    headers.put("xh", "学号");
    headers.put("xm", "学生姓名");
    headers.put("ktmc", "课题名称");
    headers.put("", "查重(是/否)");
    ex.exportExcel(headers, (String)sql, this.response, "查重数据", null);
  }
  
  @Action
  public void cctgModelDownload(LwXsmd model) {
    StringBuffer sql = new StringBuffer();
    sql.append(
        " select dbnf, case  when dbjj = 1 then '秋' when  dbjj = 0 then '春' end as dbjj, zd,zy,bj,xh,xm,ktmc");
    sql.append(" from lw_xsmd where IsDel=0 and zt=2");
    if (!Strings.isNullOrEmpty(model.getZdid()) || 
      "1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType())) {
      String zdId = "1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType()) ? 
        this.lwXsmdService.getLoginTeacher().getZdName() : 
        model.getZdid();
      sql.append(" and zdid = '" + zdId + "'");
    } 
    if (!Strings.isNullOrEmpty(model.getNf()))
      sql.append(" and nf = '" + model.getNf() + "'"); 
    if (!Strings.isNullOrEmpty(model.getDbjj()))
      sql.append(" and dbjj = '" + model.getDbjj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getXh()))
      sql.append(" and xh = '" + model.getXh() + "'"); 
    if (!Strings.isNullOrEmpty(model.getXm()))
      sql.append(" and xm = '" + model.getXm() + "'"); 
    if (!Strings.isNullOrEmpty(model.getCj()))
      sql.append(" and cj = '" + model.getCj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getDbnf()))
      sql.append(" and dbnf = '" + model.getDbnf() + "'"); 
    if (!Strings.isNullOrEmpty(model.getNj()))
      sql.append(" and nj = '" + model.getNj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getBjid()))
      sql.append(" and bjid = '" + model.getBjid() + "' "); 
    sql.append(" and sfcc = '是'");
    sql.append(" group by zdid,zyid,bjid,id");
    sql.append(" order by nf desc,zdid,zyid,bjid,xh");
    exprotEx<BaseModel> ex = new exprotEx();
    Map<String, String> headers = new LinkedHashMap<>();
    headers.put("dbnf", "答辩年份");
    headers.put("dbjj", "答辩学期");
    headers.put("zd", "站点");
    headers.put("zy", "专业");
    headers.put("bj", "班级");
    headers.put("xh", "学号");
    headers.put("xm", "学生姓名");
    headers.put("ktmc", "课题名称");
    ex.exportExcel(headers, (String)sql, this.response, "查重通过数据", null);
  }
  
  @Action
  public ActionResult zdjsUpLoad() {
    return json(this.lwXsmdService.zdjsUpLoad(getPart("excelImport")));
  }
  
  @Action
  public ActionResult sfccUpLoad() {
    return json(this.lwXsmdService.sfccUpLoad(getPart("excelImport")));
  }
  
  @Action
  public ActionResult cctgUpLoad() {
    return json(this.lwXsmdService.cctgUpLoad(getPart("excelImport")));
  }
  
  @Action
  public ActionResult lwsjUpLoad() {
    return json(this.lwXsmdService.lwsjUpLoad(getPart("excelImport")));
  }
  
  @Action
  public ActionResult setDbgzTime(String strs, String kssj, String jssj, String dbsj, String dbnf, String dbjj) {
    int result = 0;
    StringBuffer sql = new StringBuffer();
    if (Strings.isNullOrEmpty(dbsj)) {
      sql.append(" update lw_xsmd set dbgzkssj='" + kssj + "',dbgzjssj='" + jssj + "'");
      sql.append(" where zt='2'");
      sql.append("and dbnf = " + dbnf + " and dbjj = " + dbjj);
    } else {
      JSONArray arry = JSONArray.fromObject(strs);
      for (int i = 0; i < arry.size(); i++) {
        JSONObject jobj = arry.getJSONObject(i);
        sql.setLength(0);
        sql.append(" update lw_xsmd set dbsj='" + dbsj + "'");
        sql.append(" where zt='2'");
        if (!Strings.isNullOrEmpty(jobj.getString("bjid")))
          sql.append(" and bjid='" + jobj.getString("bjid") + "'"); 
        if (!Strings.isNullOrEmpty(jobj.getString("dbjj")))
          sql.append(" and dbjj='" + jobj.getString("dbjj") + "'"); 
        if (!Strings.isNullOrEmpty(jobj.getString("dbnf")))
          sql.append(" and dbnf='" + jobj.getString("dbnf") + "'"); 
        if (!Strings.isNullOrEmpty(jobj.getString("dbxzh"))) {
          sql.append(" and dbxzh='" + jobj.getString("dbxzh") + "'");
        } else {
          sql.append(" and dbxzh is Null");
        } 
        result += this.lwXsmdService.executeSql(sql);
      } 
    } 
    result += this.lwXsmdService.executeSql(sql);
    return json(Integer.valueOf(result));
  }
  
  @Action
  public void dbap(String nf, String kxxq) {
    StringBuffer sql = new StringBuffer();
    sql.append(" select CONCAT(@i := @i + 1,'') rownum, r.* from (");
    sql.append(" select r.bh,r.zd,r.bj,r.zy,count(1) dbrs,");
    sql.append(" r.dbsj,r.dbxzh,z.lianxiName as zdlxr,z.lxrsj as zdlxrsj,");
    sql.append(" z.PointDri as zddz,r.yjsxm, r.yjslxfs,r.yjsxm2, r.yjslxfs2,");
    sql.append(" r.zjsxm, r.zjslxfs,r.zjsxm2, r.zjslxfs2,r.zjsxm3, r.zjslxfs3");
    sql.append(" from lw_xsmd r ");
    sql.append(" left join jxzdgl_zdgl z on (r.zdid = z.id and z.IsDel=0)");
    sql.append(" where r.IsDel=0 and r.zt='2'");
    if ("1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType()))
      sql.append(" and r.zdid = '" + this.lwXsmdService.getLoginTeacher().getZdName() + "'"); 
    sql.append(" and dbnf='" + nf + "' and dbjj='" + kxxq + "'");
    sql.append("  group by r.nf,r.dbgzkssj,r.dbgzjssj,r.dbsj,r.dbnf,r.dbjj,r.zdid,r.zyid,r.bjid,r.nj,r.yjsid,");
    sql.append("  r.yjsid2,r.zjsid,r.zjsid2,r.zjsid3,r.dbxzh,r.yjzt");
    sql.append(" order by r.bh+0,r.dbxzh,r.zdid,r.zyid,r.bjid");
    sql.append(" ) r,(select @i:=0) s");
    exprotEx<BaseModel> ex = new exprotEx();
    Map<String, String> headers = new LinkedHashMap<>();
    headers.put("bh", "序号");
    headers.put("zd", "站点");
    headers.put("bj", "班级");
    headers.put("zy", "专业");
    headers.put("dbrs", "答辩人数");
    headers.put("dbsj", "答辩时间");
    headers.put("dbxzh", "答辩小组号");
    headers.put("zdlxr", "站点联系人");
    headers.put("zdlxrsj", "联系电话");
    headers.put("zddz", "站点地址");
    headers.put("yjsxm", "院答辩教师1");
    headers.put("yjslxfs", "院答辩教师1电话");
    headers.put("yjsxm2", "院答辩教师2");
    headers.put("yjslxfs2", "院答辩教师2电话");
    headers.put("zjsxm", "站点答辩教师1");
    headers.put("zjslxfs", "站点答辩教师1电话");
    headers.put("zjsxm2", "站点答辩教师2");
    headers.put("zjslxfs2", "站点答辩教师2电话");
    headers.put("zjsxm3", "站点答辩教师3");
    headers.put("zjslxfs3", "站点答辩教师3电话");
    ex.exportExcel(headers, (String)sql, this.response, String.valueOf(nf) + "（" + (kxxq.equals("0") ? "春" : "秋") + "）毕业论文答辩工作安排表", null);
  }
  
  @Action
  public void dbjsmb(LwXsmd model) {
    StringBuffer sql = new StringBuffer();
    sql.append(" select bh,nf,dbnf,case dbjj when '0' then '春' when '1' then '秋' end  as dbjj,");
    sql.append(" zd,nj,bj,dbxzh,count(1) xsrs");
    sql.append(" from lw_xsmd  where (dbxzh != '0' OR dbxzh is null or dbxzh = '') and IsDel=0 and zt='2'");
    if (!Strings.isNullOrEmpty(model.getZdid()) || 
      "1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType())) {
      String zdId = "1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType()) ? 
        this.lwXsmdService.getLoginTeacher().getZdName() : 
        model.getZdid();
      sql.append(" and zdid = '" + zdId + "'");
    } 
    if (!Strings.isNullOrEmpty(model.getNf()))
      sql.append(" and nf ='" + model.getNf() + "'"); 
    if (!Strings.isNullOrEmpty(model.getDbnf()))
      sql.append(" and dbnf ='" + model.getDbnf() + "'"); 
    if (!Strings.isNullOrEmpty(model.getDbjj()))
      sql.append(" and dbjj ='" + model.getDbjj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getZyid()))
      sql.append(" and zyid ='" + model.getZyid() + "'"); 
    if (!Strings.isNullOrEmpty(model.getNj()))
      sql.append(" and nj ='" + model.getNj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getBjid()))
      sql.append(" and bjid ='" + model.getBjid() + "'"); 
    if (!Strings.isNullOrEmpty(model.getJsxm())) {
      sql.append(" and (yjsxm like '%" + model.getJsxm() + "%' or");
      sql.append(" yjsxm2 like '%" + model.getJsxm() + "%' or");
      sql.append(" zjsxm like '%" + model.getJsxm() + "%' or");
      sql.append(" zjsxm2 like '%" + model.getJsxm() + "%' or");
      sql.append(" zjsxm3 like '%" + model.getJsxm() + "%' )");
    } 
    sql.append(" group by nf,dbgzkssj,dbgzjssj,dbsj,dbnf,dbjj,zdid,zyid,bjid,nj,yjsid,");
    sql.append(" yjsid2,zjsid,zjsid2,zjsid3,dbxzh,yjzt");
    sql.append(" order by bh+0");
    exprotEx<BaseModel> ex = new exprotEx();
    Map<String, String> headers = new LinkedHashMap<>();
    headers.put("bh", "编号");
    headers.put("nf", "年份");
    headers.put("dbnf", "答辩年份");
    headers.put("dbjj", "答辩学期");
    headers.put("zd", "站点");
    headers.put("nj", "年级");
    headers.put("bj", "班级");
    headers.put("xsrs", "学生人数");
    headers.put("dbxzh", "答辩组号");
    if ("1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType())) {
      headers.put("站点答辩教师1", "站点答辩教师1");
      headers.put("站点答辩教师1身份证号", "站点答辩教师1身份证号");
      headers.put("站点答辩教师1电话", "站点答辩教师1电话");
      headers.put("站点答辩教师2", "站点答辩教师2");
      headers.put("站点答辩教师2身份证号", "站点答辩教师2身份证号");
      headers.put("站点答辩教师2电话", "站点答辩教师2电话");
      headers.put("站点答辩教师3", "站点答辩教师3");
      headers.put("站点答辩教师3身份证号", "站点答辩教师3身份证号");
      headers.put("站点答辩教师3电话", "站点答辩教师3电话");
    } else {
      headers.put("院答辩教师1", "院答辩教师1");
      headers.put("院答辩教师1身份证号", "院答辩教师1身份证号");
      headers.put("院答辩教师1电话", "院答辩教师1电话");
      headers.put("院答辩教师2", "院答辩教师2");
      headers.put("院答辩教师2身份证号", "院答辩教师2身份证号");
      headers.put("院答辩教师2电话", "院答辩教师2电话");
      headers.put("院答辩教师3", "院答辩教师3");
      headers.put("院答辩教师3身份证号", "院答辩教师3身份证号");
      headers.put("院答辩教师3电话", "院答辩教师3电话");
      headers.put("站点答辩教师1", "站点答辩教师1");
      headers.put("站点答辩教师1身份证号", "站点答辩教师1身份证号");
      headers.put("站点答辩教师1电话", "站点答辩教师1电话");
      headers.put("站点答辩教师2", "站点答辩教师2");
      headers.put("站点答辩教师2身份证号", "站点答辩教师2身份证号");
      headers.put("站点答辩教师2电话", "站点答辩教师2电话");
      headers.put("站点答辩教师3", "站点答辩教师3");
      headers.put("站点答辩教师3身份证号", "站点答辩教师3身份证号");
      headers.put("站点答辩教师3电话", "站点答辩教师3电话");
    } 
    ex.exportExcel(headers, (String)sql, this.response, "答辩教师导入模板下载", null);
  }
  
  @Action
  public ActionResult dbjsUpLoad() {
    return json(this.lwXsmdService.dbjsUpLoad(getPart("excelImport")));
  }
  
  @Action
  public void dbjsExport(LwXsmd model) {
    StringBuffer sql = new StringBuffer();
    sql.append(" select bh,nf,dbnf,case dbjj when '0' then '春' when '1' then '秋' end  as dbjj,");
    sql.append(" zd,zy,nj,bj,dbxzh,count(1) xsrs,yjsxm,yjsxm2,yjsxm3,yjssfzh,yjssfzh2,yjssfzh3,");
    sql.append(" yjslxfs,yjslxfs2,yjslxfs3,zjsxm,zjsxm2,zjsxm3,zjssfzh,zjssfzh2,zjssfzh3,");
    sql.append(" zjslxfs,zjslxfs2,zjslxfs3");
    sql.append(" from lw_xsmd  where IsDel=0 and zt='2'");
    if (!Strings.isNullOrEmpty(model.getZdid()) || 
      "1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType())) {
      String zdId = "1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType()) ? 
        this.lwXsmdService.getLoginTeacher().getZdName() : 
        model.getZdid();
      sql.append(" and zdid = '" + zdId + "'");
    } 
    if (!Strings.isNullOrEmpty(model.getNf()))
      sql.append(" and nf ='" + model.getNf() + "'"); 
    if (!Strings.isNullOrEmpty(model.getDbjj()))
      sql.append(" and dbjj ='" + model.getDbjj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getZyid()))
      sql.append(" and zyid ='" + model.getZyid() + "'"); 
    if (!Strings.isNullOrEmpty(model.getNj()))
      sql.append(" and nj ='" + model.getNj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getBjid()))
      sql.append(" and bjid ='" + model.getBjid() + "'"); 
    if (!Strings.isNullOrEmpty(model.getJsxm())) {
      sql.append(" and (yjsxm like '%" + model.getJsxm() + "%' or");
      sql.append(" yjsxm2 like '%" + model.getJsxm() + "%' or");
      sql.append(" yjsxm3 like '%" + model.getJsxm() + "%' or");
      sql.append(" zjsxm like '%" + model.getJsxm() + "%' or");
      sql.append(" zjsxm2 like '%" + model.getJsxm() + "%' or");
      sql.append(" zjsxm3 like '%" + model.getJsxm() + "%' )");
    } 
    sql.append(" group by nf,dbgzkssj,dbgzjssj,dbsj,dbnf,dbjj,zdid,zyid,bjid,nj,yjsid,");
    sql.append(" yjsid2,yjsid3,zjsid,zjsid2,zjsid3,dbxzh,yjzt");
    sql.append(" order by bh+0");
    exprotEx<BaseModel> ex = new exprotEx();
    Map<String, String> headers = new LinkedHashMap<>();
    headers.put("zd", "站点");
    headers.put("zy", "专业");
    headers.put("xsrs", "人数");
    headers.put("dbxzh", "组号");
    headers.put("yjsxm", "院答辩教师1");
    headers.put("yjssfzh", "院答辩教师1身份证号");
    headers.put("yjslxfs", "院答辩教师1电话");
    headers.put("yjsxm2", "院答辩教师2");
    headers.put("yjssfzh2", "院答辩教师2身份证号");
    headers.put("yjslxfs2", "院答辩教师2电话");
    headers.put("yjsxm3", "院答辩教师3");
    headers.put("yjssfzh3", "院答辩教师3身份证号");
    headers.put("yjslxfs3", "院答辩教师3电话");
    headers.put("zjsxm", "站点答辩教师1");
    headers.put("zjssfzh", "站点答辩教师1身份证号");
    headers.put("zjslxfs", "站点答辩教师1电话");
    headers.put("zjsxm2", "站点答辩教师2");
    headers.put("zjssfzh2", "站点答辩教师2身份证号");
    headers.put("zjslxfs2", "站点答辩教师2电话");
    headers.put("zjsxm3", "站点答辩教师3");
    headers.put("zjssfzh3", "站点答辩教师3身份证号");
    headers.put("zjslxfs3", "站点答辩教师3电话");
    ex.exportExcel(headers, (String)sql, this.response, "答辩教师安排表", null);
  }
  
  @Action
  public ActionResult zhsj(String nf, String zh, String strs) {
    StringBuffer sql = new StringBuffer();
    sql.append(" update lw_xsmd set dbxzh='" + zh + "'");
    sql.append(" where IsDel=0 and zt='2'");
    if ("1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType()))
      sql.append(" and zdid = '" + this.lwXsmdService.getLoginTeacher().getZdName() + "'"); 
    int result = 0;
    if (!Strings.isNullOrEmpty(strs)) {
      JSONArray json = JSONArray.fromObject(strs);
      if (json.size() > 0)
        for (int i = 0; i < json.size(); i++) {
          StringBuffer newSql = new StringBuffer();
          newSql.append(sql);
          JSONObject job = json.getJSONObject(i);
          if (!"".equals(job.get("nf")))
            newSql.append(" and nf = '" + job.get("nf") + "'"); 
          if (!"".equals(job.get("dbnf")))
            newSql.append(" and dbnf = '" + job.get("dbnf") + "'"); 
          if (!"".equals(job.get("dbjj")))
            newSql.append(" and dbjj = '" + job.get("dbjj") + "'"); 
          if (!"".equals(job.get("zd")))
            newSql.append(" and zd = '" + job.get("zd") + "'"); 
          if (!"".equals(job.get("nj")))
            newSql.append(" and nj = '" + job.get("nj") + "'"); 
          if (!"".equals(job.get("bj")))
            newSql.append(" and bj = '" + job.get("bj") + "'"); 
          result += this.lwXsmdService.executeSql(newSql);
        }  
    } else {
      sql.append("and nf='" + nf + "'");
      result = this.lwXsmdService.executeSql(sql);
    } 
    return json(Integer.valueOf(result));
  }
  
  @Action
  public ActionResult dbsc(String strs) {
    StringBuffer sql = new StringBuffer();
    boolean flag = "1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType());
    sql.append(" update lw_xsmd set ");
    if (flag) {
      sql.append(" zjsxm=null,zjssfzh=null,zjslxfs=null,zjsid=null,");
      sql.append(" zjsxm2=null,zjssfzh2=null,zjslxfs2=null,zjsid2=null,");
      sql.append(" zjsxm3=null,zjssfzh3=null,zjslxfs3=null,zjsid3=null");
    } else {
      sql.append(" yjsxm=null,yjssfzh=null,yjslxfs=null,yjsid=null,");
      sql.append(" yjsxm2=null,yjssfzh2=null,yjslxfs2=null,yjsid2=null");
      sql.append(" yjsxm3=null,yjssfzh3=null,yjslxfs3=null,yjsid3=null");
    } 
    sql.append(" where IsDel=0 and zt=2");
    int result = 0;
    if (!Strings.isNullOrEmpty(strs)) {
      JSONArray json = JSONArray.fromObject(strs);
      if (json.size() > 0)
        for (int i = 0; i < json.size(); i++) {
          StringBuffer newSql = new StringBuffer();
          newSql.append(sql);
          JSONObject jobj = json.getJSONObject(i);
          if (!Strings.isNullOrEmpty(jobj.getString("bjid")))
            newSql.append(" and bjid='" + jobj.getString("bjid") + "'"); 
          if (!Strings.isNullOrEmpty(jobj.getString("dbnf")))
            newSql.append(" and dbnf='" + jobj.getString("dbnf") + "'"); 
          if (!Strings.isNullOrEmpty(jobj.getString("dbjj")))
            newSql.append(" and dbjj='" + jobj.getString("dbjj") + "'"); 
          if (!Strings.isNullOrEmpty(jobj.getString("dbxzh"))) {
            newSql.append(" and dbxzh='" + jobj.getString("dbxzh") + "'");
          } else {
            newSql.append(" and dbxzh is Null");
          } 
          result += this.lwXsmdService.executeSql(newSql);
        }  
    } 
    return json(Integer.valueOf(result));
  }
  
  @Action
  public ActionResult zdjsList(LwXsmd model) {
    if (model == null)
      model = new LwXsmd(); 
    StringBuffer sql = new StringBuffer();
    sql.append(" select zdjsid,zdjsxm,zdjssfzh  from lw_xsmd");
    sql.append(" where IsDel=0 and zt=2");
    sql.append(" and zdjsid is not null");
    if ("1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType()))
      sql.append(" and zdid = '" + this.lwXsmdService.getLoginTeacher().getZdName() + "'"); 
    if (model.getDbnf() != null && !model.getDbnf().equals(""))
      sql.append(" and dbnf='" + model.getDbnf() + "'"); 
    if (model.getDbjj() != null && !model.getDbjj().equals(""))
      sql.append(" and dbjj='" + model.getDbjj() + "'"); 
    if (model.getZdjsxm() != null && !model.getZdjsxm().equals(""))
      sql.append(" and zdjsxm='" + model.getZdjsxm() + "'"); 
    sql.append(" group by zdjsid");
    return json(this.lwXsmdService.queryListMapBysql(sql));
  }
  
  @Action
  public ActionResult zdjsDetailList(String ids) {
    StringBuffer sql = new StringBuffer();
    sql.append(" select teacher_name jsxm,case teacher_sex when '0' then '男'when '1' then '女' end xb,");
    sql.append(" CONCAT(SUBSTR(id_card,7,4),'-',SUBSTR(id_card,11,2),'-',SUBSTR(id_card,13,2)) csny,");
    sql.append(" technical_title zc,academic_degree xw,work_unit dw");
    sql.append(" from base_teacher where IsDel=0");
    sql.append(" and id in('" + ids.replace(",", "','") + "')");
    return json(this.lwXsmdService.queryListMapBysql(sql));
  }
  
  @Action
  public ActionResult lwqktjData(String strs) {
    return json(this.lwXsmdService.lwqktjData(strs));
  }
  
  @Action
  public ActionResult printslwqktjData(String bjid, String dbjj, String dbnf, String nj, String zdid, String zy, String yjzt, String bh) {
    String sql = "select bjid , dbjj , dbnf , dbxzh ,bh from lw_xsmd where IsDel=0  and zt=2 ";
    StringBuffer newsql = new StringBuffer();
    newsql.append(sql);
    if (!Strings.isNullOrEmpty(dbnf))
      newsql.append(" and dbnf='" + dbnf + "'"); 
    if (!Strings.isNullOrEmpty(nj))
      newsql.append(" and nj='" + nj + "'"); 
    if (!Strings.isNullOrEmpty(dbjj))
      newsql.append(" and dbjj='" + dbjj + "'"); 
    if (!Strings.isNullOrEmpty(zdid))
      newsql.append(" and zdid='" + zdid + "'"); 
    if (!Strings.isNullOrEmpty(bjid))
      newsql.append(" and bjid='" + bjid + "'"); 
    if (!Strings.isNullOrEmpty(zy))
      newsql.append(" and zy='" + zy + "'"); 
    if (!Strings.isNullOrEmpty(yjzt))
      newsql.append(" and yjzt='" + yjzt + "'"); 
    if (!Strings.isNullOrEmpty(bh))
      newsql.append(" and bh='" + bh + "'"); 
    System.out.println(this.lwXsmdService.getLoginTeacherRole().getLoginType());
    if ("1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType()))
      newsql.append(" and zdid = '" + this.lwXsmdService.getLoginTeacher().getZdName() + "'"); 
    newsql.append("GROUP BY dbnf,dbjj,bjid,dbxzh order by  bh+0, dbxzh+0 asc");
    List<Map<String, Object>> list = this.lwXsmdService.queryListMapBysql(newsql);
    List<Map<String, Object>> list2 = new ArrayList<>();
    for (int i = 0; i < list.size(); i++) {
      Map<String, Object> map = list.get(i);
      Map<String, Object> map2 = null;
      if (!map.containsKey("bjid"))
        map.put("bjid", ""); 
      if (!map.containsKey("dbjj"))
        map.put("dbjj", ""); 
      if (!map.containsKey("dbnf"))
        map.put("dbnf", ""); 
      if (!map.containsKey("dbxzh"))
        map.put("dbxzh", ""); 
      if (!map.containsKey("bh"))
        map.put("bh", ""); 
    } 
    String strs = JSON.toJSONString(list);
    return json(this.lwXsmdService.printslwqktjData(strs));
  }
  
  @Action
  public void lwqktj(String strs) {
    this.lwXsmdService.lwqktj(this.lwXsmdService.lwqktjData(strs), this.request, this.response);
  }
  
  @Action
  public void downloadslwqktj(LwXsmd model) {
    String sql = "select bjid , dbjj , dbnf , dbxzh ,bh from lw_xsmd where IsDel=0  and zt=2 ";
    StringBuffer newsql = new StringBuffer();
    newsql.append(sql);
    if (!Strings.isNullOrEmpty(model.getDbnf()))
      newsql.append(" and dbnf='" + model.getDbnf() + "'"); 
    if (!Strings.isNullOrEmpty(model.getNj()))
      newsql.append(" and nj='" + model.getNj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getDbjj()))
      newsql.append(" and dbjj='" + model.getDbjj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getZdid()))
      newsql.append(" and zdid='" + model.getZdid() + "'"); 
    if (!Strings.isNullOrEmpty(model.getBjid()))
      newsql.append(" and bjid='" + model.getBjid() + "'"); 
    if (!Strings.isNullOrEmpty(model.getZy()))
      newsql.append(" and zy='" + model.getZy() + "'"); 
    if (!Strings.isNullOrEmpty(model.getYjzt()))
      newsql.append(" and yjzt='" + model.getYjzt() + "'"); 
    if (!Strings.isNullOrEmpty(model.getBh()))
      newsql.append(" and bh='" + model.getBh() + "'"); 
    if ("1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType()))
      newsql.append(" and zdid = '" + this.lwXsmdService.getLoginTeacher().getZdName() + "'"); 
    newsql.append("GROUP BY dbnf,dbjj,bjid,dbxzh");
    List<Map<String, Object>> list = this.lwXsmdService.queryListMapBysql(newsql);
    List<Map<String, Object>> list2 = new ArrayList<>();
    for (int i = 0; i < list.size(); i++) {
      Map<String, Object> map = list.get(i);
      Map<String, Object> map2 = null;
      if (!map.containsKey("bjid"))
        map.put("bjid", ""); 
      if (!map.containsKey("dbjj"))
        map.put("dbjj", ""); 
      if (!map.containsKey("dbnf"))
        map.put("dbnf", ""); 
      if (!map.containsKey("dbxzh"))
        map.put("dbxzh", ""); 
      if (!map.containsKey("bh"))
        map.put("bh", ""); 
    } 
    String s = JSON.toJSONString(list);
    this.lwXsmdService.downloadslwqktj(this.lwXsmdService.printslwqktjData(s), this.request, this.response);
  }
  
  @Action
  public ActionResult scbh(String nf, String dbnf, String dbjj) {
    StringBuffer sql = new StringBuffer();
    sql.append(" update lw_xsmd l,(");
    sql.append(" select @i:=@i+1 r,r.* from (");
    sql.append(" select zd,zdid,bj,bjid,z.zdksm,count(1) xsrs");
    sql.append(" from LW_XSMD l");
    sql.append(" left join jxzdgl_zdgl z");
    sql.append(" on(l.zdid = z.id and z.IsDel=0)");
    sql.append(" where l.IsDel=0 and zt=2");
    sql.append(" and  dbnf='" + dbnf + "' and dbjj='" + dbjj + "'");
    sql.append(" group by bjid,nj,dbxzh ");
    sql.append(" order by z.zdksm+0,nj,bj");
    sql.append(" )r ,(select @i:=0) s ) a");
    sql.append(" set l.bh=a.r ");
    sql.append(" where (dbxzh != '0' OR dbxzh is null or dbxzh = '') and l.IsDel=0 and zt=2");
    sql.append(" and  dbnf='" + dbnf + "' and dbjj='" + dbjj + "'");
    sql.append(" and l.zdid=a.zdid and l.bjid=a.bjid");
    return json(Integer.valueOf(this.lwXsmdService.executeSql(sql)));
  }
  
  @Action
  public ActionResult szbh(String keys, String num) {
    String[] ids = keys.split(",");
    String key = "";
    for (int i = 0; i < ids.length; i++) {
      if (key.equals("")) {
        key = String.valueOf(key) + "'" + ids[i] + "'";
      } else {
        key = String.valueOf(key) + ",'" + ids[i] + "'";
      } 
    } 
    StringBuffer sql = new StringBuffer();
    sql.append("update lw_xsmd set bh = " + num);
    sql.append(" where bjid in (" + key + ")");
    sql.append(" and (bh = '' or bh is null)");
    return json(Integer.valueOf(this.lwXsmdService.executeSql(sql)));
  }
  
  @Action
  public ActionResult bjwdb(String keys) {
    String[] ids = keys.split(",");
    String key = "";
    for (int i = 0; i < ids.length; i++) {
      if (key.equals("")) {
        key = String.valueOf(key) + "'" + ids[i] + "'";
      } else {
        key = String.valueOf(key) + ",'" + ids[i] + "'";
      } 
    } 
    String sql = "select * from lw_xsmd where id in (" + key + ")";
    List<Map<String, Object>> list = new ArrayList<>();
    list = this.lwXsmdService.queryListMapBysql(sql);
    int count = 0;
    for (int n = 0; n < list.size(); n++) {
      String updateSql = "";
      if (((Map)list.get(n)).get("yjzt").equals("3")) {
        updateSql = "update lw_xsmd set yjzt = 0 where bjid = '" + ((Map)list.get(n)).get("bjid").toString() + "'" + 
          " and dbnf = '" + ((Map)list.get(n)).get("dbnf").toString() + "'" + "and dbjj = '" + (
          (Map)list.get(n)).get("dbjj").toString() + "'";
      } else {
        updateSql = "update lw_xsmd set yjzt = 3 where bjid = '" + ((Map)list.get(n)).get("bjid").toString() + "'" + 
          " and dbnf = '" + ((Map)list.get(n)).get("dbnf").toString() + "'" + "and dbjj = '" + (
          (Map)list.get(n)).get("dbjj").toString() + "'";
      } 
      count += this.lwXsmdService.executeSql(updateSql);
    } 
    return json(Integer.valueOf(count));
  }
  
  @Action
  public ActionResult cjsz(LwXsmd model) {
    xsChengJi xsChengJi = new xsChengJi();
    xsChengJi.setKcdm("07002");
    xsChengJi.setStuId(model.getXsid());
    xsChengJi = (xsChengJi)this.xsChengJiService.selectOneByColumn(xsChengJi);
    if (xsChengJi == null)
      return json("0"); 
    return json(Integer.valueOf(this.lwXsmdService.updateByColumn(model)));
  }
  
  @Action
  public ActionResult cjyj(String strs, String type) {
    int r = 0;
    JSONArray jsonArray = JSONArray.fromObject(strs);
    String name = this.lwXsmdService.getLoginTeacherRole().getName();
    SimpleDateFormat Data = new SimpleDateFormat("yyyy-MM-dd");
    Date d = new Date();
    String now = Data.format(d);
    for (int i = 0; i < jsonArray.size(); i++) {
      JSONObject jobj = jsonArray.getJSONObject(i);
      StringBuffer sql = new StringBuffer();
      sql.append(" update lw_xsmd set yjzt='" + type + "' ");
      if (type.equals("1"))
        sql.append(" , yjrxm = '" + name + "',yjsj = '" + now + "' where isDel=0 and zt='2'"); 
      if (type.equals("2"))
        sql.append(" , jsrxm = '" + name + "',jiessj = '" + now + "' where isDel=0 and zt='2'"); 
      if (!Strings.isNullOrEmpty(jobj.getString("bjid")))
        sql.append(" and bjid='" + jobj.getString("bjid") + "'"); 
      if (!Strings.isNullOrEmpty(jobj.getString("dbnf")))
        sql.append(" and dbnf='" + jobj.getString("dbnf") + "'"); 
      if (!Strings.isNullOrEmpty(jobj.getString("dbjj")))
        sql.append(" and dbjj='" + jobj.getString("dbjj") + "'"); 
      if (!Strings.isNullOrEmpty(jobj.getString("dbxzh"))) {
        sql.append(" and dbxzh='" + jobj.getString("dbxzh") + "'");
      } else {
        sql.append(" and dbxzh is Null");
      } 
      r += this.lwXsmdService.executeSql(sql);
    } 
    return json(Integer.valueOf(r));
  }
  
  @Action
  public void dbzAp(LwXsmd model) {
    StringBuffer sql = new StringBuffer();
    sql.append(" select nf,dbnf,case dbjj when '0' then '春' else '秋' end dbjj,");
    sql.append(" zd,zy,xq,nj,bj,xh,xm,dbxzh");
    sql.append(" from lw_xsmd where IsDel=0 and zt=2");
    if (!Strings.isNullOrEmpty(model.getZdid()) || 
      "1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType())) {
      String zdId = "1".equals(this.lwXsmdService.getLoginTeacherRole().getLoginType()) ? 
        this.lwXsmdService.getLoginTeacher().getZdName() : 
        model.getZdid();
      sql.append(" and zdid = '" + zdId + "'");
    } 
    if (!Strings.isNullOrEmpty(model.getNf()))
      sql.append(" and nf = '" + model.getNf() + "'"); 
    if (!Strings.isNullOrEmpty(model.getDbnf()))
      sql.append(" and dbnf = '" + model.getDbnf() + "'"); 
    if (!Strings.isNullOrEmpty(model.getDbjj()))
      sql.append(" and dbjj = '" + model.getDbjj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getZyid()))
      sql.append(" and zyid = '" + model.getZyid() + "'"); 
    if (!Strings.isNullOrEmpty(model.getXq()))
      sql.append(" and xq = '" + model.getXq() + "'"); 
    if (!Strings.isNullOrEmpty(model.getNj()))
      sql.append(" and nj = '" + model.getNj() + "'"); 
    if (!Strings.isNullOrEmpty(model.getBjid()))
      sql.append(" and bjid = '" + model.getBjid() + "'"); 
    if (!Strings.isNullOrEmpty(model.getXh()))
      sql.append(" and xh = '" + model.getXh() + "'"); 
    if (!Strings.isNullOrEmpty(model.getXm()))
      sql.append(" and xm = '" + model.getXm() + "'"); 
    if (!Strings.isNullOrEmpty(model.getDbxzh()))
      sql.append(" and dbxzh = '" + model.getDbxzh() + "'"); 
    sql.append(" group by zdid,zyid,bjid,id");
    sql.append(" order by nf desc,zdid,zyid,bjid");
    exprotEx<BaseModel> ex = new exprotEx();
    Map<String, String> headers = new LinkedHashMap<>();
    headers.put("nf", "年份");
    headers.put("dbnf", "答辩年份");
    headers.put("dbjj", "答辩学期");
    headers.put("zd", "站点");
    headers.put("zy", "专业");
    headers.put("xq", "论文学期");
    headers.put("nj", "年级");
    headers.put("bj", "班级");
    headers.put("xh", "学号");
    headers.put("xm", "学生姓名");
    headers.put("dbxzh", "答辩组号");
    ex.exportExcel(headers, (String)sql, this.response, "答辩组安排", null);
  }
  
  @Action
  public ActionResult dbzhSz(String ids, String dbxzh) {
    String sql = "update lw_xsmd set dbxzh= %s where id in('%s')";
    return json(
        Integer.valueOf(this.lwXsmdService.executeSql(String.format(sql, new Object[] { (dbxzh == "") ? null : dbxzh, ids.replace(",", "','") }))));
  }
  
  @Action
  public ActionResult dbyjprints(LwXsmd model) {
    return json(this.lwXsmdService.Lwdbyj(model));
  }
  
  @Action
  public ActionResult xgpd() {
    String sql = "select * from lw_xsmd order by CreateTime desc limit 1";
    Map<String, Object> map = this.lwXsmdService.queryMapBysql(sql);
    return json(map);
  }
  
  @Action
  public ActionResult tqkk(String keys) {
    String[] bjids = keys.split(",");
    String key = "";
    for (int i = 0; i < bjids.length; i++) {
      if (key.equals("")) {
        key = String.valueOf(key) + "'" + bjids[i] + "'";
      } else {
        key = String.valueOf(key) + ",'" + bjids[i] + "'";
      } 
    } 
    StringBuffer sql = new StringBuffer();
    sql.append(" select kc.xn as nf,bj.zdId as zdId,");
    sql.append(" bj.zd as zdmc,bj.nj as nj,bj.zyId as zyId,bj.zydm as zydm,");
    sql.append(" bj.zy as zymc,kc.jbjhdm as jbjhdm, kc.ssjhdm");
    sql.append(" as ssjhdm, bj.cc as cc, bj.xs as xs,bj.xz as xz,");
    sql.append(" bj.jhxxnx as jhxxnx, kc.xq as xq, kc.kcid as kcid,");
    sql.append(" kc.kcdm as kcdm,kc.kcmc as kcmc,kc.xf as xf,kc.zxs");
    sql.append(" as zxs,kc.jk as jx,kc.sj as sj,kc.zx as zx,kc.kwlb");
    sql.append(" as kslb,kc.xwk as xwk,bj.id as bjid,bj.`code` as bjdm,");
    sql.append(" bj.`name` as bjmc, bj.bjrs as bjrs");
    sql.append(" from sm_bj bj left join jxgl_jxjh_kc kc");
    sql.append(" on (bj.jhid = kc.jhid and bj.ssjhdm = kc.ssjhdm");
    sql.append(" and bj.jbjhdm = kc.jbjhdm\tand kc.IsDel = 0)");
    sql.append(" where bj.IsDel=0 and kc.id is not null");
    sql.append(" and kc.kcdm ='07002'");
    sql.append(" AND bj.id in (" + key + ")");
    sql.append(" and bj.zddm is not null");
    StringBuffer selectSql = new StringBuffer();
    selectSql.append(" select id from new_kkgl where IsDel=0");
    selectSql.append(" and nf='%s' and zdId='%s' and bjid='%s' and kcdm='%s'");
    selectSql.append(" and xq='%s' and jbjhdm='%s' and ssjhdm='%s' and semester='%s'");
    StringBuffer insertSql = new StringBuffer();
    insertSql.append(" insert into new_kkgl(id,nf,semester,zdId,zdmc,nj,zyId,zydm,zymc,jbjhdm,");
    insertSql.append(" ssjhdm,cc,xs,xz,jhxxnx,xq,kcid,kcdm,kcmc,xf,zxs,jx,sj,zx,");
    insertSql.append(" kslb,xwk,bjid,bjdm,bjmc,bjrs,gjzydm,CreateId,CreateName,CreateTime)");
    insertSql.append(" values('%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s',");
    insertSql.append(" '%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s',");
    insertSql.append(" '%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s')");
    StringBuffer gjdmSql = new StringBuffer();
    gjdmSql.append(" select gjdm from jichuxinxi_zysz_bb");
    gjdmSql.append(" where IsDel= 0 and zyid='%s' and zydm='%s'");
    gjdmSql.append(" order by bb desc limit 1 ");
    ((Map)this.lwXsmdService.queryListMapBysql(sql.toString()).stream()
      .collect(Collectors.groupingBy(s -> s.get("bjid").toString()))).forEach((k, v) -> {
          String str = v.stream().map(()).reduce(()).orElse("");
        });
    return json(Integer.valueOf(0));
  }
  
  @Action
  public ActionResult settgtj(String dbnf, String dbxq, String yyl, String type, String zfs, String lx) {
    String updateCol1 = "";
    String updateCol2 = "";
    String sql = "";
    if (type.equals("0")) {
      updateCol1 = "dbtj";
      updateCol2 = "sfkdb";
      sql = "UPDATE `lw_xsmd` set " + updateCol1 + " = '" + yyl + "' , " + updateCol2 + " = if(ccyyl <" + yyl + 
        
        " , 1 ,0) WHERE dbnf = '" + dbnf + "' AND dbjj = '" + dbxq + 
        "'AND IsDel = 0 and ccyyl is not null and ccyyl != '' and zyid in (select id from jichuxinxi_zysz where bysjlx = '" + 
        lx + "')";
    } else if (type.equals("1")) {
      updateCol1 = "xwtj";
      updateCol2 = "sfhqxw";
      String sql2 = "UPDATE `lw_xsmd` set " + updateCol2 + " = 0," + updateCol1 + "='" + yyl + "' " + 
        " WHERE dbnf = '" + dbnf + "' AND dbjj = '" + dbxq + 
        "'AND IsDel = 0 and ccyyl is not null and ccyyl != ''";
      this.lwXsmdService.executeSql(sql2);
      sql = "UPDATE `lw_xsmd` set " + updateCol1 + " = '" + yyl + "' , " + updateCol2 + " = if(ccyyl <" + yyl + 
        "  and (fqxw is null or fqxw = '') , 1 ,0) WHERE dbnf = '" + dbnf + "' AND dbjj = '" + dbxq + 
        "'AND IsDel = 0 and ccyyl is not null and ccyyl != '' and sfkdb = 1 ";
    } 
    int r = this.lwXsmdService.executeSql(sql);
    return json(Integer.valueOf(r));
  }
  
  @Action
  public void exportPhoto(LwXsmd model) throws Exception {
    List<LwXsmd> list = this.lwXsmdService.selectAllByColumn(model);
    List<String> sList = new ArrayList<>();
    List<String> Listname = new ArrayList<>();
    String address = "D:" + File.separator + "学生放弃学位";
    for (int i = 0; i < list.size(); i++) {
      if (((LwXsmd)list.get(i)).getFqxw() != null && ((LwXsmd)list.get(i)).getFqxw() != "") {
        String wzdz = String.valueOf(address) + ((LwXsmd)list.get(i)).getFqxw();
        String name = "";
        name = String.valueOf(((LwXsmd)list.get(i)).getXh()) + ".jpg";
        Listname.add(name);
        sList.add(wzdz);
      } 
    } 
    String path = "D:" + File.separator + "学生放弃学位文件";
    File file = new File(path);
    if (!file.exists())
      file.mkdirs(); 
    if (sList.size() > 0)
      for (int j = 0; j < sList.size(); j++) {
        Path form = (new File(sList.get(j))).toPath();
        Path target = (new File(String.valueOf(path) + File.separator + (String)Listname.get(j))).toPath();
        Files.copy(form, target, new java.nio.file.CopyOption[0]);
      }  
    String zipAddress = "D:/" + Tools.getUUID() + ".zip";
    ZipCompressor zc = new ZipCompressor(zipAddress);
    zc.compress(path);
    this.response.setCharacterEncoding("UTF-8");
    this.response.setContentType("application/");
    this.response.setHeader("content-disposition", 
        "attachment;filename=" + new String("学生放弃学位文件".getBytes("gb2312"), "ISO8859-1") + ".zip");
    File files = new File(zipAddress);
    FileInputStream in = new FileInputStream(files);
    ServletOutputStream servletOutputStream = this.response.getOutputStream();
    int b;
    while ((b = in.read()) != -1)
      servletOutputStream.write(b); 
    in.close();
    servletOutputStream.flush();
    servletOutputStream.close();
    files.delete();
    deleteFile(file);
  }
}
